################################################################################
# TIME PERIOD CONFIGURATION
#
# SYNTAX:
# timeperiod[<timeperiod_name>]=<timeperiod_alias>;<sun_timeranges>;
#                               <mon_timeranges>;<tue_timeranges>;
#                               <wed_timeranges>;<thu_timeranges>;
#                               <fri_timeranges>;<sat_timeranges>
#
# <timeperiod_name>             = A short name used to identify the time period
# <timeperiod_alias>		= A longer name and/or description of the time 
#                                 period
# <xx_timeranges>               = Time ranges during the day.  Ranges are in the
#                                 following format (based on a 24 hour clock)
#				  and represent intervals of time (with a start 
#                                 and end time).  Multiple time ranges per day
#                                 should be separated with commas.
#
#      Example: 09:00-17:00  (9:00am to 5:00pm)
#      Example: 00:00-8:00,17:00-24:00  (12:00am to 8:00am AND 5:00pm-12:00am)
#
#      A NULL value for a particular day indicates that no times are valid 
#      during that particular day of the week.
#
################################################################################
<!-- BEGIN config_time -->

timeperiod[{tp_name}]={tp_alias};{tp_sun};{tp_mon};{tp_tue};{tp_wed};{tp_thu};{tp_fri};{tp_sat}

<!-- END config_time -->
